package dev.shadowsoffire.apotheosis.village.compat;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.village.fletching.FletchingRecipe;
import dev.shadowsoffire.apotheosis.village.fletching.FletchingScreen;
import java.util.Arrays;
import java.util.List;
import mezz.jei.api.constants.VanillaTypes;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.drawable.IDrawable;
import mezz.jei.api.helpers.IGuiHelper;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.recipe.RecipeIngredientRole;
import mezz.jei.api.recipe.RecipeType;
import mezz.jei.api.recipe.category.IRecipeCategory;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.block.Blocks;

public class FletchingCategory implements IRecipeCategory<FletchingRecipe> {
  public static final ResourceLocation UID = new ResourceLocation("apotheosis", "fletching");
  
  public static final RecipeType<FletchingRecipe> TYPE = RecipeType.create("apotheosis", "fletching", FletchingRecipe.class);
  
  private final IDrawable background;
  
  private final IDrawable icon;
  
  private final Component localizedName;
  
  public FletchingCategory(IGuiHelper guiHelper) {
    ResourceLocation location = FletchingScreen.TEXTURES;
    this.background = (IDrawable)guiHelper.createDrawable(location, 6, 16, 139, 54);
    this.icon = guiHelper.createDrawableIngredient((IIngredientType)VanillaTypes.ITEM_STACK, new ItemStack((ItemLike)Blocks.f_50622_));
    this.localizedName = (Component)Component.m_237115_("apotheosis.recipes.fletching");
  }
  
  public IDrawable getBackground() {
    return this.background;
  }
  
  public IDrawable getIcon() {
    return this.icon;
  }
  
  public Component getTitle() {
    return this.localizedName;
  }
  
  public RecipeType<FletchingRecipe> getRecipeType() {
    return TYPE;
  }
  
  public void setRecipe(IRecipeLayoutBuilder builder, FletchingRecipe recipe, IFocusGroup focuses) {
    List<List<ItemStack>> inputs = recipe.m_7527_().stream().map(i -> Arrays.asList(i.m_43908_())).toList();
    for (int i = 0; i < 3; i++)
      builder.addSlot(RecipeIngredientRole.INPUT, 42, 1 + i * 18).addIngredients((IIngredientType)VanillaTypes.ITEM_STACK, inputs.get(i)); 
    builder.addSlot(RecipeIngredientRole.OUTPUT, 117, 19).addIngredient((IIngredientType)VanillaTypes.ITEM_STACK, recipe.getOutput());
  }
}
